---------------------
PatchSet 4095 
Date: 2002/04/30 17:21:47
Author: serassio
Branch: nt-2_3
Tag: (none) 
Log:
Commit of 11/04/2002 build sources with new socket code

Members: 
	include/autoconf.h:1.1.2.9->1.1.2.10 
	include/snmp_impl.h:1.1.1.1.44.2->1.1.1.1.44.3 
	include/squid-mswin.h:1.1.2.6->1.1.2.7 
	lib/rfc1035.c:1.1.1.1.4.3.2.2->1.1.1.1.4.3.2.3 
	lib/util.c:1.1.1.3.4.2.2.3->1.1.1.3.4.2.2.4 
	lib/win32lib.c:1.1.2.9->1.1.2.10 
	snmplib/snmp_vars.c:1.1.1.2.56.1->1.1.1.2.56.2 
	src/acl.c:1.1.1.3.4.3.2.6->1.1.1.3.4.3.2.7 
	src/cache_manager.c:1.1.1.2.4.1.2.4->1.1.1.2.4.1.2.5 
	src/cf.data.pre:1.1.1.3.4.3.2.4->1.1.1.3.4.3.2.5 
	src/client_side.c:1.1.1.3.4.6.2.8->1.1.1.3.4.6.2.9 
	src/comm.c:1.1.1.3.4.1.2.10->1.1.1.3.4.1.2.11 
	src/comm_select.c:1.1.1.3.4.2.2.4->1.1.1.3.4.2.2.5 
	src/defines.h:1.1.1.3.4.2.2.6->1.1.1.3.4.2.2.7 
	src/delay_pools.c:1.1.1.3.4.2.2.3->1.1.1.3.4.2.2.4 
	src/disk.c:1.1.1.3.4.1.2.7->1.1.1.3.4.1.2.8 
	src/dns_internal.c:1.1.1.1.4.6.2.9->1.1.1.1.4.6.2.10 
	src/errorpage.c:1.1.1.3.4.3.2.3->1.1.1.3.4.3.2.4 
	src/fd.c:1.1.1.3.4.1.2.6->1.1.1.3.4.1.2.7 
	src/forward.c:1.1.1.3.4.1.2.6->1.1.1.3.4.1.2.7 
	src/fqdncache.c:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	src/ftp.c:1.1.1.3.4.3.2.9->1.1.1.3.4.3.2.10 
	src/globals.h:1.1.1.3.4.2.2.6->1.1.1.3.4.2.2.7 
	src/gopher.c:1.1.1.3.4.2.2.2->1.1.1.3.4.2.2.3 
	src/helper.c:1.1.1.3.24.1->1.1.1.3.24.2 
	src/http.c:1.1.1.3.4.3.2.4->1.1.1.3.4.3.2.5 
	src/ident.c:1.1.1.3.4.1.2.4->1.1.1.3.4.1.2.5 
	src/ipcache.c:1.1.1.3.4.1.2.2->1.1.1.3.4.1.2.3 
	src/main.c:1.1.1.3.4.2.2.14->1.1.1.3.4.2.2.15 
	src/pconn.c:1.1.1.2.4.1.2.1->1.1.1.2.4.1.2.2 
	src/protos.h:1.1.1.3.4.1.2.12->1.1.1.3.4.1.2.13 
	src/pump.c:1.1.1.3.4.1.2.1->1.1.1.3.4.1.2.2 
	src/refresh.c:1.1.1.3.4.1.2.3->1.1.1.3.4.1.2.4 
	src/ssl.c:1.1.1.3.4.1.2.4->1.1.1.3.4.1.2.5 
	src/stat.c:1.1.1.3.4.1.2.7->1.1.1.3.4.1.2.8 
	src/structs.h:1.1.1.3.4.2.2.7->1.1.1.3.4.2.2.8 
	src/tools.c:1.1.1.3.4.1.2.16->1.1.1.3.4.1.2.17 
	src/typedefs.h:1.1.1.3.4.1.2.3->1.1.1.3.4.1.2.4 
	src/wais.c:1.1.1.2.4.1.2.1->1.1.1.2.4.1.2.2 
	src/win32.c:1.1.2.15->1.1.2.16 
	win/cf_gen/cf_gen.dsp:1.1.2.3->1.1.2.4 
	win/squidnt/squidnt.dsp:1.1.2.9->1.1.2.10 

Index: squid/include/autoconf.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Attic/autoconf.h,v
retrieving revision 1.1.2.9
retrieving revision 1.1.2.10
diff -u -r1.1.2.9 -r1.1.2.10
--- squid/include/autoconf.h	1 Nov 2001 17:31:07 -0000	1.1.2.9
+++ squid/include/autoconf.h	30 Apr 2002 17:21:47 -0000	1.1.2.10
@@ -26,7 +26,7 @@
 
 /* Define to `int' if <sys/types.h> doesn't define.  */
 #undef pid_t
-#define pid_t int
+#define pid_t long
 
 /* Define to `unsigned' if <sys/types.h> doesn't define.  */
 #undef size_t
@@ -93,7 +93,7 @@
  * Traffic management via "delay pools".
  */
 #undef DELAY_POOLS
-#define DELAY_POOLS 1
+// #define DELAY_POOLS 1
 
 /*
  * If you want to log User-Agent request header values, define this.
@@ -165,31 +165,31 @@
 
 /* Default FD_SETSIZE value */
 #undef DEFAULT_FD_SETSIZE
-#define DEFAULT_FD_SETSIZE 64
+#define DEFAULT_FD_SETSIZE 256
 
 /* Maximum number of open filedescriptors */
 #undef SQUID_MAXFD
-#define SQUID_MAXFD 8192
+#define SQUID_MAXFD 2048
 
 /* UDP send buffer size */
 #undef SQUID_UDP_SO_SNDBUF
-#define SQUID_UDP_SO_SNDBUF 512
+#define SQUID_UDP_SO_SNDBUF 16384
 
 /* UDP receive buffer size */
 #undef SQUID_UDP_SO_RCVBUF
-#define SQUID_UDP_SO_RCVBUF 512
+#define SQUID_UDP_SO_RCVBUF 16384
 
 /* TCP send buffer size */
 #undef SQUID_TCP_SO_SNDBUF
-#define SQUID_TCP_SO_SNDBUF 512
+#define SQUID_TCP_SO_SNDBUF 16384
 
 /* TCP receive buffer size */
 #undef SQUID_TCP_SO_RCVBUF
-#define SQUID_TCP_SO_RCVBUF 512
+#define SQUID_TCP_SO_RCVBUF 16384
 
 /* Host type from configure */
 #undef CONFIG_HOST_TYPE
-#define CONFIG_HOST_TYPE "WIN32"
+#define CONFIG_HOST_TYPE "i386-pc-winnt"
 
 /* If we need to declare sys_errlist[] as external */
 #undef NEED_SYS_ERRLIST
@@ -233,7 +233,7 @@
  * should be defined to int.
  */
 #undef socklen_t
-#define socklen_t long  
+#define socklen_t int  
 /*
  * By default (for now anyway) Squid includes options which allows
  * the cache administrator to violate the HTTP protocol specification
@@ -258,7 +258,7 @@
  * type of fd_set array
  */
 #undef fd_mask
-#define fd_mask long 
+#define fd_mask int 
 /*
  * If _res structure has nsaddr_list member
  */
@@ -284,7 +284,8 @@
  * the dnsserver processes instead.
  */
 #undef USE_DNSSERVERS
-// #define USE_DNSSERVERS 1
+#define USE_DNSSERVERS 1
+
 /*
  * we check for the existance of struct mallinfo
  */
Index: squid/include/snmp_impl.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/snmp_impl.h,v
retrieving revision 1.1.1.1.44.2
retrieving revision 1.1.1.1.44.3
diff -u -r1.1.1.1.44.2 -r1.1.1.1.44.3
--- squid/include/snmp_impl.h	16 Feb 2002 18:20:32 -0000	1.1.1.1.44.2
+++ squid/include/snmp_impl.h	30 Apr 2002 17:21:47 -0000	1.1.1.1.44.3
@@ -1,5 +1,5 @@
 /*
- * $Id: snmp_impl.h,v 1.1.1.1.44.2 2002/02/16 18:20:32 serassio Exp $
+ * $Id: snmp_impl.h,v 1.1.1.1.44.3 2002/04/30 17:21:47 serassio Exp $
  */
 
 #ifndef _SNMP_IMPL_H_
@@ -44,15 +44,6 @@
 #endif
 #endif
 
-/*
- * Error codes:
- */
-/*
- * These must not clash with SNMP error codes (all positive).
- */
-#define PARSE_ERROR	-1
-#define BUILD_ERROR	-2
-
 #define SID_MAX_LEN	64
 
 #ifndef NULL
Index: squid/include/squid-mswin.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/include/Attic/squid-mswin.h,v
retrieving revision 1.1.2.6
retrieving revision 1.1.2.7
diff -u -r1.1.2.6 -r1.1.2.7
--- squid/include/squid-mswin.h	10 Feb 2002 17:55:55 -0000	1.1.2.6
+++ squid/include/squid-mswin.h	30 Apr 2002 17:21:47 -0000	1.1.2.7
@@ -1,5 +1,5 @@
 /*
- * $Id: squid-mswin.h,v 1.1.2.6 2002/02/10 17:55:55 serassio Exp $
+ * $Id: squid-mswin.h,v 1.1.2.7 2002/04/30 17:21:47 serassio Exp $
  *
  * AUTHOR: Guido Serassio & Andrey Shorin
  *
@@ -35,11 +35,12 @@
 
 #define __STDC__ 1
 
+#undef HAVE_SYS_TIME_H
+
 #pragma include_alias(<dirent.h>, <direct.h>)
 
 #define alloca _alloca
 #define chdir _chdir
-#define close _close
 #define dup _dup
 #define dup2 _dup2
 #define fdopen _fdopen
@@ -69,10 +70,6 @@
 #define unlink _unlink
 #define vsnprintf _vsnprintf
 
-// temp
-#define read       _read
-#define write      _write
-
 #define O_RDONLY _O_RDONLY
 #define O_BINARY _O_BINARY
 #define O_WRONLY _O_WRONLY
@@ -124,9 +121,14 @@
 
 #include <stddef.h>
 #include <process.h>
+/* Hack to suppress compiler warnings on FD_SET() & FD_CLR() */
+#pragma warning (push)
+#pragma warning (disable:4142)
+typedef int SOCKET;
 /* prevent inclusion of wingdi.h */
 #define NOGDI
 #include <ws2spi.h>
+#pragma warning (pop)
 #include "readdir.h"
 
 typedef char *caddr_t;
@@ -143,45 +145,185 @@
 #define ECONNRESET WSAECONNRESET
 #define ERESTART WSATRY_AGAIN
 
-#if defined (COMM_C) || defined (COMM_SELECT_C)
-#define recv(x,y,z) recv(x,y,z,0)
-#define send(x,y,z) send(x,y,z,0)
-#define fd_bytes(x,y,z) sd_bytes(x,y,z)
-#define fd_note(x,y) sd_note(x,y)
-#define fd_open(x,y,z) sd_open(x,y,z)
-#define fd_close(x) sd_close(x)
-#define ignoreErrno(x) WSAignoreErrno(x)
-#endif
-
-#if defined (ICP_V2_C)
-#define fd_note(x,y) sd_note(x,y)
-#define ignoreErrno(x) WSAignoreErrno(x)
-#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
-#endif
-
-#if defined (SNMP_CORE_C)
-#define fd_note(x,y) sd_note(x,y)
-#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
+/* internal to CRTLIB */
+#define FPIPE           0x08    /* file handle refers to a pipe */
+typedef struct {
+        long osfhnd;    /* underlying OS file HANDLE */
+        char osfile;    /* attributes of file (e.g., open in text mode?) */
+        char pipech;    /* one char buffer for handles opened on pipes */
+#ifdef _MT
+        int lockinitflag;
+        CRITICAL_SECTION lock;
+#endif  /* _MT */
+    }   ioinfo;
+extern _CRTIMP ioinfo * __pioinfo[];
+#define IOINFO_L2E          5
+#define IOINFO_ARRAY_ELTS   (1 << IOINFO_L2E)
+#define _pioinfo(i) ( __pioinfo[(i) >> IOINFO_L2E] + ((i) & (IOINFO_ARRAY_ELTS - 1)) )
+#define _osfile(i)  ( _pioinfo(i)->osfile )
+int __cdecl _free_osfhnd(int);
+
+#undef h_errno
+#define h_errno errno /* we'll set it ourselves */
+
+#undef FD_CLR
+#define FD_CLR(fd, set) do { \
+    u_int __i; \
+    SOCKET __sock = _get_osfhandle(fd); \
+    for (__i = 0; __i < ((fd_set FAR *)(set))->fd_count ; __i++) { \
+        if (((fd_set FAR *)(set))->fd_array[__i] == __sock) { \
+            while (__i < ((fd_set FAR *)(set))->fd_count-1) { \
+                ((fd_set FAR *)(set))->fd_array[__i] = \
+                    ((fd_set FAR *)(set))->fd_array[__i+1]; \
+                __i++; \
+            } \
+            ((fd_set FAR *)(set))->fd_count--; \
+            break; \
+        } \
+    } \
+} while(0)
+
+#undef FD_SET
+#define FD_SET(fd, set) do { \
+    u_int __i; \
+    SOCKET __sock = _get_osfhandle(fd); \
+    for (__i = 0; __i < ((fd_set FAR *)(set))->fd_count; __i++) { \
+        if (((fd_set FAR *)(set))->fd_array[__i] == (__sock)) { \
+            break; \
+        } \
+    } \
+    if (__i == ((fd_set FAR *)(set))->fd_count) { \
+        if (((fd_set FAR *)(set))->fd_count < FD_SETSIZE) { \
+            ((fd_set FAR *)(set))->fd_array[__i] = (__sock); \
+            ((fd_set FAR *)(set))->fd_count++; \
+        } \
+    } \
+} while(0)
+
+#undef FD_ISSET
+#define FD_ISSET(fd, set) __WSAFDIsSet((SOCKET)(_get_osfhandle(fd)), (fd_set FAR *)(set))
+
+extern __declspec(thread) int ws32_result;
+
+#if !defined(_etext) /* util.c actually */
+#define strerror(e) xbstrerror(e)
+#else
+#define NOT_NEEDED 1
 #endif
 
-#if defined(WHOIS_C) || defined(WAIS_C) 
-#define send(x,y,z) send(x,y,z,0)
-#define recv(x,y,z) recv(x,y,z,0)
-#define fd_bytes(x,y,z) sd_bytes(x,y,z)
-#define ignoreErrno(x) WSAignoreErrno(x)
-#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
+/* internal to CRTLIB */
+/* used also in win32lib.c */
+extern void __cdecl _dosmaperr(unsigned long oserrno);
+
+#define socket(f,t,p) \
+	(INVALID_SOCKET == ((SOCKET)ws32_result = socket(f,t,p)) ? \
+	((WSAEMFILE == (errno = WSAGetLastError()) ? errno = EMFILE : -1), -1) : \
+	(SOCKET)_open_osfhandle(ws32_result,0))
+#define accept(s,a,l) \
+	(INVALID_SOCKET == ((SOCKET)ws32_result = accept(_get_osfhandle(s),a,l)) ? \
+	((WSAEMFILE == (errno = WSAGetLastError()) ? errno = EMFILE : -1), -1) : \
+	(SOCKET)_open_osfhandle(ws32_result,0))
+#define bind(s,n,l) \
+	(SOCKET_ERROR == bind(_get_osfhandle(s),n,l) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define connect(s,n,l) \
+	(SOCKET_ERROR == connect(_get_osfhandle(s),n,l) ? \
+	(WSAEMFILE == (errno = WSAGetLastError()) ? errno = EMFILE : -1, -1) : 0)
+#define listen(s,b) \
+	(SOCKET_ERROR == listen(_get_osfhandle(s),b) ? \
+	(WSAEMFILE == (errno = WSAGetLastError()) ? errno = EMFILE : -1, -1) : 0)
+#define shutdown(s,h) \
+	(SOCKET_ERROR == shutdown(_get_osfhandle(s),h) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define closesocket(s) \
+	{ \
+	(SOCKET_ERROR == closesocket(_get_osfhandle(s)) ? \
+	(errno = WSAGetLastError()), -1 : 0); \
+	_free_osfhnd(s); \
+	_osfile(s) = 0; \
+	} 
+#define select(n,r,w,e,t) \
+	(SOCKET_ERROR == (ws32_result = select(n,r,w,e,t)) ? \
+	(errno = WSAGetLastError()), -1 : ws32_result)
+#define recv(s,b,l,f) \
+	(SOCKET_ERROR == (ws32_result = recv(_get_osfhandle(s),b,l,f)) ? \
+	(errno = WSAGetLastError()), -1 : ws32_result)
+#define recvfrom(s,b,l,f,fr,frl) \
+	(SOCKET_ERROR == (ws32_result = recvfrom(_get_osfhandle(s),b,l,f,fr,frl)) ? \
+	(errno = WSAGetLastError()), -1 : ws32_result)
+#define send(s,b,l,f) \
+	(SOCKET_ERROR == (ws32_result = send(_get_osfhandle(s),b,l,f)) ? \
+	(errno = WSAGetLastError()), -1 : ws32_result)
+#define sendto(s,b,l,f,t,tl) \
+	(SOCKET_ERROR == (ws32_result = sendto(_get_osfhandle(s),b,l,f,t,tl)) ? \
+	(errno = WSAGetLastError()), -1 : ws32_result)
+#define getsockname(s,n,l) \
+	(SOCKET_ERROR == getsockname(_get_osfhandle(s),n,l) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define getsockopt(s,l,o,v,n) \
+	(Sleep(1), SOCKET_ERROR == getsockopt(_get_osfhandle(s),l,o,(char*)v,n) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define setsockopt(s,l,o,v,n) \
+	(SOCKET_ERROR == setsockopt(_get_osfhandle(s),l,o,v,n) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define ioctlsocket(s,c,a) \
+	(SOCKET_ERROR == ioctlsocket(_get_osfhandle(s),c,a) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define gethostname(n,l) \
+	(SOCKET_ERROR == gethostname(n,l) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#define gethostbyname(n) \
+	(NULL == ((HOSTENT FAR*)ws32_result = gethostbyname(n)) ? \
+	(errno = WSAGetLastError()), NULL : (HOSTENT FAR*)ws32_result)
+#define getservbyname(n,p) \
+	(NULL == ((SERVENT FAR*)ws32_result = getservbyname(n,p)) ? \
+	(errno = WSAGetLastError()), NULL : (SERVENT FAR*)ws32_result)
+#define gethostbyaddr(a,l,t) \
+	(NULL == ((HOSTENT FAR*)ws32_result = gethostbyaddr(a,l,t)) ? \
+	(errno = WSAGetLastError()), NULL : (HOSTENT FAR*)ws32_result)
+#undef WSASocket
+#ifdef UNICODE
+#define WSASocket(a,t,p,i,g,f) \
+	(INVALID_SOCKET == ((SOCKET)ws32_result = WSASocketW(a,t,p,i,g,f)) ? \
+	((WSAEMFILE == (errno = WSAGetLastError()) ? errno = EMFILE : -1), -1) : \
+	(SOCKET)_open_osfhandle(ws32_result,0))
+#else
+#define WSASocket(a,t,p,i,g,f) \
+	(INVALID_SOCKET == ((SOCKET)ws32_result = WSASocketA(a,t,p,i,g,f)) ? \
+	((WSAEMFILE == (errno = WSAGetLastError()) ? errno = EMFILE : -1), -1) : \
+	(SOCKET)_open_osfhandle(ws32_result,0))
+#endif /* !UNICODE */
+#undef WSADuplicateSocket
+#ifdef UNICODE
+#define WSADuplicateSocket(s,n,l) \
+	(SOCKET_ERROR == WSADuplicateSocketW(_get_osfhandle(s),n,l) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#else
+#define WSADuplicateSocket(s,n,l) \
+	(SOCKET_ERROR == WSADuplicateSocketA(_get_osfhandle(s),n,l) ? \
+	(errno = WSAGetLastError()), -1 : 0)
+#endif /* !UNICODE */
+
+#if defined(STORE_IO_C) || defined(STORE_DIR_C) || defined(TOOLS_C)
+#define read  _read
+#define write _write
+#else
+extern __declspec(thread) int _so_err;
+extern __declspec(thread) int _so_err_siz;
+#define read(fd,buf,siz) \
+	(_so_err_siz = sizeof(_so_err), \
+	getsockopt((fd),SOL_SOCKET,SO_ERROR,&_so_err,&_so_err_siz) \
+	== 0 ? recv((fd),(buf),(siz),0) : _read((fd),(buf),(siz)))
+#define write(fd,buf,siz) \
+	(_so_err_siz = sizeof(_so_err), \
+	getsockopt((fd),SOL_SOCKET,SO_ERROR,&_so_err,&_so_err_siz) \
+	== 0 ? send((fd),(buf),(siz),0) : _write((fd),(buf),(siz)))
 #endif
 
-#if defined (SSL_C) || defined (PCONN_C) || defined (PUMP_C) ||  \
-	defined (HTTP_C) || defined (HTCP_C) || defined (HELPER_C) || defined (CLIENT_SIDE_C) \
-	|| defined (FTP_C) || defined (GOPHER_C) || defined(IDENT_C) || \
-	defined (ICMP_C) || defined (FORWARD_C) || defined (DNS_INTERNAL_C)
-#define recv(x,y,z) recv(x,y,z,0)
-#define send(x,y,z) send(x,y,z,0)
-#define fd_bytes(x,y,z) sd_bytes(x,y,z)
-#define fd_note(x,y) sd_note(x,y)
-#define ignoreErrno(x) WSAignoreErrno(x)
-#define commSetSelect(x,y,z,u,v) commSetSelectS(x,y,z,u,v)
+#if defined(COMM_C) || defined(TOOLS_C)
+#define close closesocket
+#else
+#define close _close
 #endif
 
 #define	RUSAGE_SELF	0		/* calling process */
